SystemOrganization addCategory: #'Manifest-CriticBrowser'!

!RBCompositeLintRule methodsFor: '*Manifest-CriticBrowser' stamp: 'SimonAllier 7/31/2012 11:05'!
removeRule: aRule

	(rules anySatisfy: [:rule | rule name = aRule name] )
		ifTrue: [rules := rules reject:  [:rule | rule name = aRule name]]
		 ifFalse: [rules do: [:rule |
				rule isComposite 
					ifTrue: [rule removeRule: aRule]]] ! !

!RBCompositeLintRule methodsFor: '*Manifest-CriticBrowser' stamp: 'SimonAllier 8/21/2012 15:30'!
sort: aBlock
	
	rules first isComposite
		 ifTrue: [rules do: [:rule |
					rule sort: aBlock]] 
		ifFalse: [ 
			self rules: (rules sort: aBlock)]! !

ComposableModel subclass: #CommentWindow
	instanceVariableNames: 'okCancelToolBarModel commentInputFieldModel rule critic'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Manifest-CriticBrowser'!

CommentWindow subclass: #CommentFalsePositiveWindow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Manifest-CriticBrowser'!

!CommentFalsePositiveWindow class methodsFor: 'instance creation' stamp: 'SimonAllier 4/2/2012 13:31'!
openOnCritic: aCritc onRule: aRule
	
	self new
		critic: aCritc;
		rule: aRule;
		initForFalsePositive;		
		openWithSpec. ! !

!CommentFalsePositiveWindow methodsFor: 'initialization' stamp: 'SimonAllier 5/29/2012 11:38'!
initForFalsePositive
	self initTextForFalsePositive.
	
	okCancelToolBarModel okAction: [ | manifestBuilder rId rV|
		rId :=  rule class uniqueIdentifierName.
		rV :=   rule class identifierMinorVersionNumber.
		manifestBuilder := BuilderManifest on: critic.
		
		(manifestBuilder hasFalsePositiveOf: rId version: rV) 
			ifFalse: [manifestBuilder installFalsePositiveOf: rId version: rV].
		
		manifestBuilder
			addFalsePositive: critic  withComment:  (commentInputFieldModel getText)  of: rId version: rV]! !

!CommentFalsePositiveWindow methodsFor: 'initialization' stamp: 'SimonAllier 4/13/2012 16:59'!
initTextForFalsePositive
| ruleId versionId  manifestBuilder|
		
	manifestBuilder := 	BuilderManifest on: critic.
	ruleId :=  rule class uniqueIdentifierName.
	versionId :=   rule class identifierMinorVersionNumber.
	
	(manifestBuilder hasFalsePositiveOf: ruleId version: versionId)
		ifFalse: [^ self] .
	
	commentInputFieldModel text: ((BuilderManifest on: critic) commentOfFalsePositive: critic onRule: ruleId version: versionId)  ! !

CommentWindow subclass: #CommentToDoWindow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Manifest-CriticBrowser'!

!CommentToDoWindow class methodsFor: 'instance creation' stamp: 'SimonAllier 4/2/2012 13:29'!
openOnCritic: aCritc onRule: aRule
	
	self new
		critic: aCritc;
		rule: aRule;
		initForToDo;		
		openWithSpec. ! !

!CommentToDoWindow methodsFor: 'initialization' stamp: 'SimonAllier 5/29/2012 11:38'!
initForToDo
	self initTextForToDo.
	
	okCancelToolBarModel okAction: [ | manifestBuilder rId rV|
		rId :=  rule class uniqueIdentifierName.
		rV :=   rule class identifierMinorVersionNumber.
		manifestBuilder := BuilderManifest on: critic.
		
		(manifestBuilder hasToDoOf: rId version: rV) 
			ifFalse: [manifestBuilder installToDoOf: rId version: rV].
		
		manifestBuilder
			addToDo: critic  withComment:  (commentInputFieldModel getText)  of: rId version: rV]! !

!CommentToDoWindow methodsFor: 'initialization' stamp: 'SimonAllier 4/13/2012 16:59'!
initTextForToDo
	| ruleId versionId  manifestBuilder|
		
	manifestBuilder := 	BuilderManifest on: critic.
	ruleId :=  rule class uniqueIdentifierName.
	versionId :=   rule class identifierMinorVersionNumber.
	
	(manifestBuilder hasToDoOf: ruleId version: versionId)
		ifFalse: [^ self] .
	
	commentInputFieldModel text: ((BuilderManifest on: critic) commentOfToDo: critic onRule: ruleId version: versionId)  ! !

!CommentWindow class methodsFor: 'specs' stamp: 'SimonAllier 7/25/2012 10:24'!
defaultSpec
	
	^ { #Panel.
			#useProportionalLayout.
			
			#add:. {{#model.	#commentInputField.}	.
							#layout:. {#FrameLayout.
										#fractions:offsets:. (0@0 corner: 1@1). (0@0 corner: 0@(-25))}}.
			
			#add:. {{#model.	#okCancelToolBar.}	.
							#layout:. {#FrameLayout.
										#fractions:offsets:. (0@1 corner: 1@1). (0@(-25) corner: 0@0)}}.
			
			
			#hSpaceFill.
			#vSpaceFill }! !

!CommentWindow class methodsFor: 'specs' stamp: 'SimonAllier 3/30/2012 15:04'!
title
	^ 'Comment'! !

!CommentWindow methodsFor: 'accessing' stamp: 'SimonAllier 3/30/2012 14:58'!
commentInputField
	^ commentInputFieldModel! !

!CommentWindow methodsFor: 'accessing' stamp: 'SimonAllier 3/30/2012 15:50'!
critic: aCritic
	critic := aCritic! !

!CommentWindow methodsFor: 'protocol' stamp: 'SimonAllier 4/10/2012 15:58'!
initialExtent

	^  (265@125)! !

!CommentWindow methodsFor: 'initialization' stamp: 'SimonAllier 5/9/2012 16:42'!
initialize

	super initialize.
	
	okCancelToolBarModel := self instantiate: OkCancelToolbar. 
	commentInputFieldModel := self instantiate: TextModel.
	
	"commentInputFieldModel removeEntryCompletion "
	! !

!CommentWindow methodsFor: 'initialization' stamp: 'SimonAllier 7/25/2012 10:20'!
initializeWidgets 

! !

!CommentWindow methodsFor: 'protocol' stamp: 'SimonAllier 3/30/2012 16:02'!
okAction: aBlock
	^ okCancelToolBarModel okAction: aBlock! !

!CommentWindow methodsFor: 'accessing' stamp: 'SimonAllier 3/30/2012 14:58'!
okCancelToolBar
	^ okCancelToolBarModel! !

!CommentWindow methodsFor: 'accessing' stamp: 'SimonAllier 3/30/2012 15:50'!
rule: aRule
	rule := aRule! !

ComposableModel subclass: #CriticBrowser
	instanceVariableNames: 'rule criticsModel toolbarModel sourceCodeModel critics textInputFieldModel checker thread'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Manifest-CriticBrowser'!

!CriticBrowser commentStamp: '<historical>' prior: 0!
I'am a browser for the SmallLint Critics of a rule

Instance Variables
	criticsModel:		<Object>
	rule:		<Object>
	textModel:		<Object>
	toolbarModel:		<Object>

criticsModel
	- xxxxx

rule
	- xxxxx

textModel
	- xxxxx

toolbarModel
	- xxxxx
!

!CriticBrowser class methodsFor: 'specs' stamp: 'SimonAllier 9/28/2012 13:53'!
defaultSpec
	<spec>
	
	^ SpecLayout composed
		newColumn: [:c |
			c 
				add: #criticsModel;
				add: #toolbarModel height: 25;
				addSplitter;
				add: #textModel ]! !

!CriticBrowser class methodsFor: 'specs' stamp: ''!
title

	^ 'Critic Browser'! !

!CriticBrowser methodsFor: 'menu' stamp: 'SimonAllier 5/23/2012 15:34'!
addAllCriticToFalsePositive: aSetOfCritic on: aManifestBuilder
	| ruleId versionId  |
	
	
	ruleId :=  rule class uniqueIdentifierName.
	versionId :=   rule class identifierMinorVersionNumber.
	
	
	(aManifestBuilder hasFalsePositiveOf: ruleId version: versionId) 
			ifFalse: [aManifestBuilder installFalsePositiveOf: ruleId version: versionId].
				
	 aManifestBuilder addAllFalsePositive: aSetOfCritic of: ruleId version: versionId.
	! !

!CriticBrowser methodsFor: 'menu' stamp: 'SimonAllier 5/23/2012 15:34'!
addAllCriticsToFalsePositive

	(criticsModel listItems groupedBy: [:each | checker manifestBuilderOf: each]) 
			keysAndValuesDo: [:key :value |
				self addAllCriticToFalsePositive: value on: key].
	self updateList
			! !

!CriticBrowser methodsFor: 'menu' stamp: 'SimonAllier 5/22/2012 16:48'!
addClassToFalsePositive

	| manifestBuilder|
	
	criticsModel selectedItems ifNotNil: [ :criticss |
		criticss do: [ :critic |
			manifestBuilder := checker manifestBuilderOf: critic.
			critic isCompiledMethod 
				ifTrue: [ manifestBuilder addRejectClass: critic methodClass]
				ifFalse: [ manifestBuilder addRejectClass: critic]].
		self updateList
	]	! !

!CriticBrowser methodsFor: 'menu' stamp: 'SimonAllier 5/23/2012 15:33'!
addCriticToFalsePositive

	criticsModel selectedItems
		ifNotNil: [:criticss | 
			(criticss groupedBy: [:each | checker manifestBuilderOf: each]) 
				keysAndValuesDo: [:key :value |
					
					self addAllCriticToFalsePositive: value on: key]].
		self updateList! !

!CriticBrowser methodsFor: 'menu' stamp: 'SimonAllier 4/13/2012 16:59'!
addCriticToFalsePositive: aCritic
	| ruleId versionId manifestBuilder |
	
	
	ruleId :=  rule class uniqueIdentifierName.
	versionId :=   rule class identifierMinorVersionNumber.
	
	manifestBuilder := checker manifestBuilderOf: aCritic.
	
	(manifestBuilder hasFalsePositiveOf: ruleId version: versionId) 
			ifFalse: [manifestBuilder installFalsePositiveOf: ruleId version: versionId].
				
	 manifestBuilder addFalsePositive: aCritic of: ruleId version: versionId.
	! !

!CriticBrowser methodsFor: 'menu' stamp: 'SimonAllier 5/23/2012 15:54'!
addCriticToToDo

	|  ruleId versionId|
	
	ruleId :=  rule class uniqueIdentifierName.
	versionId :=   rule class identifierMinorVersionNumber.
	
	criticsModel selectedItems 
		ifNotNil: [:criticss | 
			(criticss groupedBy: [:each | checker manifestBuilderOf: each]) 
				keysAndValuesDo: [:manifestBuilder :critis |
					
					(manifestBuilder hasToDoOf: ruleId version: versionId) 
						ifFalse: [manifestBuilder installToDoOf: ruleId version: versionId].
	 				manifestBuilder addAllToDo: critis of: ruleId version: versionId]].
	
	self updateList
	 ! !

!CriticBrowser methodsFor: 'menu' stamp: 'SimonAllier 5/22/2012 16:49'!
addCriticWithCommentToFalsePositive
	| aCritic |
	
	aCritic := criticsModel selectedItem.
	
	aCritic isNil 
		ifTrue: [^ self]. 
	
	self addCriticToFalsePositive: aCritic.
	self  updateList.
	CommentFalsePositiveWindow openOnCritic: aCritic onRule: rule. 

	
	! !

!CriticBrowser methodsFor: 'menu' stamp: 'SimonAllier 4/2/2012 13:32'!
addCriticWithCommentToToDo
	| aCritic |
	
	aCritic := criticsModel selectedItem.
	
	aCritic isNil 
		ifTrue: [^ self]. 
	
	self addCriticToToDo.
	CommentToDoWindow openOnCritic: aCritic onRule: rule. 
	
	! !

!CriticBrowser methodsFor: 'menu' stamp: 'SimonAllier 5/22/2012 16:49'!
addRuleToFalsePositive

	| manifestBuilder |
	criticsModel selectedItems ifNotNil: [ :criticss |
		criticss do: [ :critic |
		manifestBuilder := checker manifestBuilderOf: critic.. 
	
		manifestBuilder addRejectRule: rule class uniqueIdentifierName]].
	self updateList
	! !

!CriticBrowser methodsFor: 'menu' stamp: ''!
browseCritic
	criticsModel selectedItem
		ifNotNil: [:elem | 
			elem isBehavior 
				ifTrue: [ elem theNonMetaClass  browse]
				ifFalse: [elem browse] ] ! !

!CriticBrowser methodsFor: 'accessing' stamp: 'SimonAllier 3/29/2012 10:40'!
checker: aChecker
 
	checker := aChecker! !

!CriticBrowser methodsFor: 'accessing' stamp: 'SimonAllier 5/21/2012 15:31'!
critics: aCollectionOfcritic

	 criticsModel  items: aCollectionOfcritic
	! !

!CriticBrowser methodsFor: 'accessing' stamp: ''!
criticsModel

	^ criticsModel! !

!CriticBrowser methodsFor: 'private' stamp: 'SimonAllier 5/21/2012 11:25'!
criticsModelContains: aCritic

	^ criticsModel listItems anySatisfy: [:each |
		aCritic isCompiledMethod
			ifTrue: [
				 each isCompiledMethod 
					ifTrue: [ each methodClass = aCritic methodClass and: [ each selector = aCritic selector  ]]
					ifFalse: [false]
				 ]
			ifFalse: [each = aCritic ] ]! !

!CriticBrowser methodsFor: 'private' stamp: 'SimonAllier 8/28/2012 10:55'!
defaultColor

	^ Color red! !

!CriticBrowser methodsFor: 'private' stamp: ''!
falsePositiveColor

	^ Color darkGray! !

!CriticBrowser methodsFor: 'private' stamp: 'SimonAllier 3/29/2012 15:39'!
formatCritic: aCritic
	| ret |
	ret := aCritic isCompiledMethod
		ifTrue: [ aCritic methodClass name , '>>#' , aCritic selector ]
		ifFalse: [ aCritic name ].
	ret := ret , ' (' , (checker manifestBuilderOf: aCritic) packageName , ')'.
	^ ret! !

!CriticBrowser methodsFor: 'private' stamp: 'SimonAllier 8/29/2012 13:40'!
iconFor: anItem
	| manifestBuilder rId rV |
	rId := rule class uniqueIdentifierName.
	rV := rule class identifierMinorVersionNumber.
	

	^  (checker isFalsePositive: anItem forRuleId:  rId versionId: rV) 
			ifFalse: [(checker isToDo: anItem forRuleId:  rId versionId: rV)
				ifTrue: [CriticBrowserIcons wrenchOrangeIcon ]
				ifFalse:[CriticBrowserIcons exclamationIcon]
			]! !

!CriticBrowser methodsFor: 'menu' stamp: ''!
implementorsOfCritic

	criticsModel selectedItem
		ifNotNil: [:elem | 
			elem isBehavior 
				ifTrue: [ elem theNonMetaClass  browse]
				ifFalse: [(AbstractTool new ) browseMessagesFrom:  elem selector] ] ! !

!CriticBrowser methodsFor: 'initialization' stamp: 'SimonAllier 9/28/2012 13:53'!
initActionToPerformOnTextModel
	| selectedItem |
	
	sourceCodeModel acceptBlock:  [:text | 	
		selectedItem := criticsModel selectedItem.
		((selectedItem isCompiledMethod) and: [rule isTransformationRule not])
			ifTrue: [ selectedItem methodClass compile: text ] 
			ifFalse: [ Compiler evaluate:  text ]]
	
! !

!CriticBrowser methodsFor: 'initialization' stamp: 'SimonAllier 8/28/2012 16:12'!
initDisplayCritic: aCritic forRuleId: ruleId versionId: versionId 
	
	| ret | 
	
	ret := self formatCritic: aCritic.
	
	^ (checker isFalsePositive: aCritic forRuleId:  ruleId versionId: versionId) 
			ifTrue: [ret asStringMorph color: self falsePositiveColor ]
			ifFalse: [(checker isToDo: aCritic forRuleId:  ruleId versionId: versionId)
				ifTrue: [ret asStringMorph color: self toDoColor]
				ifFalse:[
					ret asStringMorph color: self defaultColor]]
	
		! !

!CriticBrowser methodsFor: 'initialization' stamp: 'SimonAllier 7/25/2012 13:57'!
initTextInputFieldModel
	textInputFieldModel := self instantiate: TextInputFieldModel.
	textInputFieldModel autoAccept: true.
	textInputFieldModel removeEntryCompletion.

	
	textInputFieldModel acceptBlock: [: text | |matchText|
		matchText := '*', text, '*'.
		self critics: (text isEmpty 
			ifTrue: [critics]
			ifFalse: [ critics select: [:critic |
				matchText match: (self formatCritic: critic)]]).
		self updateList]
! !

!CriticBrowser methodsFor: 'initialization' stamp: 'SimonAllier 3/29/2012 17:07'!
initToolBar
	
	self toolbarModel whenFalsePositiveClickedDo: [ self addCriticToFalsePositive ].
	self toolbarModel whenTransformClickedDo: [ self removeSelectedItemFromListModel ].
	
! !

!CriticBrowser methodsFor: 'initialization' stamp: 'SimonAllier 9/28/2012 13:53'!
initializePresenter

	self whenSelectedItemChangesOnListModel.
	

! !

!CriticBrowser methodsFor: 'initialization' stamp: 'SimonAllier 9/28/2012 13:53'!
initializeWidgets

	self instantiateModels: #(
		criticsModel IconListModel
		sourceCodeModel TextModel 
		toolbarModel CriticToolbar ).

	criticsModel beMultipleSelection.
		
	self initTextInputFieldModel.
	self initToolBar.
	self initActionToPerformOnTextModel.

	criticsModel displayBlock: [:selec |
		self 
			initDisplayCritic: selec 
			forRuleId: (rule class uniqueIdentifierName)
			versionId: (rule class identifierMinorVersionNumber) ]. 
	
	criticsModel menu: [:a :b | self menu: a shifted: b ].
	criticsModel icons: [:item | self iconFor: item ].
	
	self focusOrder
		add: criticsModel;
		add: toolbarModel;
		add: sourceCodeModel.
! !

!CriticBrowser methodsFor: 'menu' stamp: 'SimonAllier 3/30/2012 17:25'!
menu: aMenu shifted: aBoolean

	aMenu
		add: 'Browse' translated
		target: self
		selector: #browseCritic;
		add: 'Senders' translated
		target: self
		selector: #sendersOfCritic;
		add: 'Implementors' translated
		target: self
		selector: #implementorsOfCritic;
		addLine;
		add: 'Mark selected critic as false Positive' translated
		target: self
		selector: #addCriticToFalsePositive;
		add: 'Mark selected critic as false Positive with a comment' translated
		target: self
		selector: #addCriticWithCommentToFalsePositive;
		add: 'Unmark selected critic as false Positive' translated 
		target: self
		selector: #removeCriticToFalsePositive;
		add: 'Mark all critics as false Positive' translated
		target: self
		selector: #addAllCriticsToFalsePositive;
		add: 'Unmark all critics as false Positive' translated
		target: self
		selector: #removeAllCriticsToFalsePositive;
		addLine;
		add: 'Mark selected critic as TODO' translated
		target: self
		selector: #addCriticToToDo;
		add: 'Mark selected critic as TODO with comment' translated
		target: self
		selector: # addCriticWithCommentToToDo;
		add: 'Unmark selected critic as TODO' translated
		target: self
		selector: #removeCriticToToDo;
		addLine;
		add: 'Mark selected class as false Positive' translated
		target: self
		selector: #addClassToFalsePositive;
		add: 'Unmark selected class as false Positive' translated
		target: self
		selector: #removeClassToFalsePositive;
		addLine;
		add: 'Ban this rule for the selected package' translated
		target: self
		selector: #addRuleToFalsePositive;
		add: 'Unban this rule for the selected package' translated
		target: self
		selector: #removeRuleToFalsePositive.
		
	^ aMenu! !

!CriticBrowser methodsFor: 'message handling' stamp: 'SimonAllier 5/21/2012 14:28'!
perform: selector orSendTo: otherTarget
	"If I wish to intercept and handle selector myself, do it; else send it to otherTarget"
	^ (self respondsTo: selector) ifTrue: [self perform: selector] ifFalse: [otherTarget perform: selector]! !

!CriticBrowser methodsFor: 'private' stamp: 'SimonAllier 5/23/2012 15:36'!
removeAllCriticToFalsePositive: aSetOfCritic on: aManifestBuilder
	| ruleId versionId  |
	

	ruleId :=  rule class uniqueIdentifierName.
	versionId :=   rule class identifierMinorVersionNumber.


	(aManifestBuilder hasFalsePositiveOf: ruleId version: versionId) 
			ifTrue: [ aManifestBuilder removeAllFalsePositive: aSetOfCritic of: ruleId version: versionId].
				
	! !

!CriticBrowser methodsFor: 'menu' stamp: 'SimonAllier 5/23/2012 15:48'!
removeAllCriticsToFalsePositive
	(criticsModel  listItems groupedBy: [:each | checker manifestBuilderOf: each]) 
		keysAndValuesDo: [:key :value |
			self removeAllCriticToFalsePositive: value on: key].
		
	self updateList
			! !

!CriticBrowser methodsFor: 'menu' stamp: 'SimonAllier 5/22/2012 16:49'!
removeClassToFalsePositive

	| manifestBuilder |
	criticsModel selectedItems
		ifNotNil: [:criticss | criticss do: [:critic |
			manifestBuilder := checker manifestBuilderOf: critic. 
	
			critic isCompiledMethod 
				ifTrue: [ manifestBuilder removeRejectClass: critic methodClass]
				ifFalse: [ manifestBuilder removeRejectClass: critic theNonMetaClass ]]].
	self  updateList
	! !

!CriticBrowser methodsFor: 'menu' stamp: 'SimonAllier 5/23/2012 15:43'!
removeCriticToFalsePositive
	criticsModel selectedItems
		ifNotNil: [:criticss | 
			(criticss groupedBy: [:each | checker manifestBuilderOf: each]) 
				keysAndValuesDo: [:key :value |
					
					self removeAllCriticToFalsePositive: value on: key]].
		self updateList! !

!CriticBrowser methodsFor: 'menu' stamp: 'SimonAllier 5/23/2012 15:56'!
removeCriticToToDo
	|  ruleId versionId|
	
	ruleId :=  rule class uniqueIdentifierName.
	versionId :=   rule class identifierMinorVersionNumber.
	
	criticsModel selectedItems 
		ifNotNil: [:criticss | 
			(criticss groupedBy: [:each | checker manifestBuilderOf: each]) 
				keysAndValuesDo: [:manifestBuilder :critis |
					
					(manifestBuilder hasToDoOf: ruleId version: versionId) 
						ifTrue: [	manifestBuilder removeAllToDo: critis of: ruleId version: versionId]].
	 			].
	
	self updateList
	 ! !

!CriticBrowser methodsFor: 'menu' stamp: 'SimonAllier 5/22/2012 16:49'!
removeRuleToFalsePositive

	| manifestBuilder |
	
	criticsModel selectedItems ifNotNil: [ :criticss |
		criticss do: [ :critic |
			manifestBuilder := checker manifestBuilderOf: critic.
			manifestBuilder removeRejectRule: rule class uniqueIdentifierName]]
		.
	self  updateList
	! !

!CriticBrowser methodsFor: 'private' stamp: 'SimonAllier 5/22/2012 16:50'!
removeSelectedItemFromListModel
	| item block |
	item := criticsModel selectedItem.
	block := item isCompiledMethod
		ifTrue: [ [ :each | each methodClass = item methodClass and: [ each selector = item selector ] ] ]
		ifFalse: [ [ :each | each = item ] ].
	criticsModel items: (criticsModel listItems reject: block).
	self resetSelection.
	self  updateList! !

!CriticBrowser methodsFor: 'protocol' stamp: ''!
resetSelection

	self criticsModel resetSelection! !

!CriticBrowser methodsFor: 'initialization' stamp: 'SimonAllier 7/25/2012 10:08'!
rule: aRule

	rule := aRule.
	
	(rule isNil or: [rule isComposite ]) 
		ifTrue: [ ^ self].	
	critics := rule critics.
	
	criticsModel items: rule critics.
	toolbarModel rule: rule.! !

!CriticBrowser methodsFor: 'private' stamp: ''!
selectionIntervalFor: aString
	^ rule result selectionIntervalFor: aString! !

!CriticBrowser methodsFor: 'menu' stamp: ''!
sendersOfCritic

	| abstractTool |
	
	abstractTool := AbstractTool new. 	
	criticsModel selectedItem
		ifNotNil: [:elem | 
			elem isBehavior 
				ifTrue: [ abstractTool browseClassRefsOf: elem]
				ifFalse: [abstractTool browseSendersOfMessagesFrom: elem selector] ] ! !

!CriticBrowser methodsFor: 'initialization' stamp: ''!
setTextModelFoClass: cl
	| interval |

	sourceCodeModel aboutToStyle: true.
	sourceCodeModel text: cl definition.
	sourceCodeModel behavior: nil .
	
	interval := (self selectionIntervalFor: cl definition).
	interval ifNotNil: [sourceCodeModel setSelection: interval].
	
	
					! !

!CriticBrowser methodsFor: 'initialization' stamp: ''!
setTextModelForMethod: selection
	| interval |

	sourceCodeModel aboutToStyle: true.
	sourceCodeModel text: selection sourceCode.
	sourceCodeModel behavior: selection methodClass.
	
	interval := (self selectionIntervalFor: selection sourceCode).
	interval ifNotNil: [sourceCodeModel setSelection: interval].
	
	
					! !

!CriticBrowser methodsFor: 'initialization' stamp: 'SimonAllier 8/22/2012 11:23'!
setTextModelForNil
	| text |
	
	text := rule longDescription isEmpty 
		ifTrue: [rule name]
		ifFalse:[rule longDescription]. 
	sourceCodeModel aboutToStyle: false.
	sourceCodeModel text: text.
	sourceCodeModel behavior: nil.
	toolbarModel critic: nil 
	
	
					! !

!CriticBrowser methodsFor: 'initialization' stamp: ''!
setTextModelForTransformationRule: selection
	
	| textDiff change |
	rule result.
	change := rule changes detect: [:ch |
		((ch changeClassName) = (selection methodClass name)) & (ch selector = selection selector)].
	textDiff := (TextDiffBuilder
		from: (selection sourceCode)
		to:  (change source) inClass: selection methodClass) buildDisplayPatch.
	
	sourceCodeModel behavior: nil.
	sourceCodeModel text: textDiff.
	sourceCodeModel aboutToStyle: false.

									
					! !

!CriticBrowser methodsFor: 'private-focus' stamp: ''!
takeKeyboardFocus

	^ self criticsModel takeKeyboardFocus! !

!CriticBrowser methodsFor: 'accessing' stamp: 'SimonAllier 3/27/2012 17:18'!
textInputFieldModel
	^ textInputFieldModel! !

!CriticBrowser methodsFor: 'accessing' stamp: ''!
textModel

	^ sourceCodeModel! !

!CriticBrowser methodsFor: 'private' stamp: 'SimonAllier 8/28/2012 10:38'!
toDoColor

	^ Color orange! !

!CriticBrowser methodsFor: 'accessing' stamp: ''!
toolbarModel

	^ toolbarModel! !

!CriticBrowser methodsFor: 'thread' stamp: 'SimonAllier 5/22/2012 16:47'!
updateList

	thread ifNotNil: [ thread terminate ].
	thread := [ WorldState addDeferredUIMessage: [ criticsModel updateList ]] fork.! !

!CriticBrowser methodsFor: 'initialization' stamp: 'SimonAllier 5/29/2012 10:24'!
whenSelectedItemChangesOnListModel

	criticsModel whenSelectedItemChanged: [:selection |
		rule isNil ifFalse: [.
		(selection
			ifNil: [self setTextModelForNil]
			ifNotNil: [
				toolbarModel critic: selection.
				rule isTransformationRule 
					ifTrue: [self setTextModelForTransformationRule: selection]
					ifFalse: [				
						(rule result isSelectorEnvironment or: [rule result isMultiEnvironment])
							ifTrue: [  self setTextModelForMethod: selection]
							ifFalse:  [ self setTextModelFoClass: selection]]
				])]]! !

ComposableModel subclass: #CriticRulesBrowser
	instanceVariableNames: 'criticModel rulesModel environment countOfFalsePositive countOfToDo checker thread countOfProblem title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Manifest-CriticBrowser'!

!CriticRulesBrowser commentStamp: '<historical>' prior: 0!
I'am a browser for the SmallLint Critics

example: 
	rule :=  RBCompositeLintRule filterRules.
environment := (PackageEnvironment new packages: {PackageInfo named: 'Manifest'}).

(CriticRulesBrowser runRule: rule onEnvironment: environment)
	openWithSpec.
	
!

!CriticRulesBrowser class methodsFor: 'specs' stamp: 'SimonAllier 9/28/2012 13:55'!
defaultSpec
	<spec>
	
	^ SpecLayout composed 
		newColumn: [:c |
			c 
				newRow: [:r |
					r 
						add: #rulesModel;
						addSplitter;
						newColumn: [:c1 |
							c1 
								add: #(criticModel textInputFieldModel) height: 25;
								add: #(criticModel criticsModel);
								add: #(criticModel toolbarModel) height: 25 ]];
				addSplitter;
				add: #(criticModel textModel) ]! !

!CriticRulesBrowser class methodsFor: 'menu' stamp: 'SimonAllier 8/28/2012 11:01'!
finderMenuOn: aBuilder 
	"I build a menu"
	<worldMenu>
	(aBuilder item: 'Critic Browser')
		action: [SelectPackageBrowser open];
		order: 0;
		parent: #Tools;
		help: 'To manage rule checks';
		icon: self icon! !

!CriticRulesBrowser class methodsFor: 'menu' stamp: ''!
icon
	"Answer an icon for the receiver."
	
	^self theme smallWarningIcon! !

!CriticRulesBrowser class methodsFor: 'instance creation' stamp: 'SimonAllier 8/1/2012 11:03'!
open

	| env rules  |
	rules :=  RBCompositeLintRule allGoodRules rules.
	env := (RBPackageEnvironment new packages: ((MCWorkingCopy  allManagers asOrderedCollection) copyFrom: 1 to: 20)).
	
	self openOnRule: rules onEnvironment:  env
	

	.! !

!CriticRulesBrowser class methodsFor: 'instance creation' stamp: 'SimonAllier 5/22/2012 15:55'!
openOnRule: aRule onEnvironment: aEnv

	| cbr |
	cbr :=  self new rules: aRule;
		environment: aEnv;
		yourself.

	cbr openWithSpec.
	cbr applyRules. 
	cbr rulesModel  changed:  #listElementAt:.! !

!CriticRulesBrowser class methodsFor: 'instance creation' stamp: 'SimonAllier 7/31/2012 11:06'!
packagesGroup: aBuilder
	<nautilusGroupMenu>
	| packages target env rules group|
	target := aBuilder model.
	
	
	(group := target selectedGroups) ifNil: [ ^ target ].
	
	packages := (group gather: [:each | each classes collect: [:cl |
			PackageInfo named: (cl package name)]]) asSet.
	
	rules :=   RBCompositeLintRule allGoodRules.
	env := (RBPackageEnvironment new packages: packages ).	
	
	(aBuilder item: #'Critics Browser')
		action: [self openOnRule: rules onEnvironment: env];
		help: 'Running critics rules on this group'.! !

!CriticRulesBrowser class methodsFor: 'instance creation' stamp: 'SimonAllier 7/31/2012 11:06'!
packagesMenu: aBuilder
	<nautilusPackageMenu>
	| packages target env rules |
	target := aBuilder model.

	(packages := target selectedPackages) ifNil: [ ^ {target} ].

	
	rules :=  RBCompositeLintRule allGoodRules.
	env := (RBPackageEnvironment new packages: (packages collect: [:each | PackageInfo named: (each name)]) ).	
	
	
	(aBuilder item: #'Critics Browser')
		action: [self  openOnRule: rules onEnvironment: env];
		help: 'Running critics rules on this package'.! !

!CriticRulesBrowser class methodsFor: 'menu' stamp: ''!
theme
	^ UITheme current! !

!CriticRulesBrowser methodsFor: 'user interface' stamp: 'SimonAllier 8/23/2012 10:57'!
addModelItemsToWindowMenu: aMenu
	"Add model-related items to the window menu"
	"super addModelItemsToWindowMenu: aMenu."
	
	aMenu addLine;
		add: 'Clean all manifest'
		target: checker
		action: #cleanAllManifest;
		add: 'Reapply all  rules'
		target: self
		action: #reapplyAllRules! !

!CriticRulesBrowser methodsFor: 'private' stamp: 'SimonAllier 5/22/2012 16:51'!
addRuleToFalsePositive

	| manifestBuilder |
	rulesModel selectedItem ifNotNil: [ :rule |
		rule leaves do: [: r |
			r critics do: [:cl |
				manifestBuilder := checker manifestBuilderOf: cl. 
				manifestBuilder addRejectRule: r class uniqueIdentifierName]
		]].
	criticModel updateList. 	
	! !

!CriticRulesBrowser methodsFor: 'private' stamp: 'SimonAllier 4/13/2012 17:00'!
addTruePositive: aItem onRule: aRule	

	| ruleId versionId manifestBuilder |

	ruleId :=  aRule class uniqueIdentifierName.
	versionId :=   aRule class identifierMinorVersionNumber.

	manifestBuilder :=  checker manifestBuilderOf: aItem..
	
	(manifestBuilder hasTruePositiveOf: ruleId version: versionId) 
			ifFalse: [manifestBuilder installTruePositiveOf: ruleId version: versionId].
				
	manifestBuilder addTruePositive: aItem of: ruleId version: versionId.
	
	! !

!CriticRulesBrowser methodsFor: 'private' stamp: 'SimonAllier 9/28/2012 15:11'!
applyRules
	|  packageCount nbPackage process rules|
	
	rules := rulesModel getRoots first.
	rules resetResult.
	
	nbPackage := environment packages size.
	packageCount := 0.
	self updateTree.
	process := [  
		environment packages do: [:package |
			packageCount := packageCount + 1.
			self setTitle: 'run rules on ', package packageName, ' (',packageCount asString, '/', nbPackage asString ,')'  .
			checker runRules: rules onPackage: package.
			
			]. 	
		self setTitle: 'Critics Browser'.
		self initFPTOCount. 
		"rulesModel getRoots first sort: [:r1 :r2 |
				(checker defectLikeHoodOf: r1) > (checker defectLikeHoodOf: r2)]."
		self updateTree.
			self registerToAnnouncements.
	]
		newProcess.
	process name: 'SmallLint'.
	process resume.
	
	
	
	! !

!CriticRulesBrowser methodsFor: 'private' stamp: ''!
browseRule
	rulesModel selectedItem 
		ifNotNil: [:rule | rule browse]! !

!CriticRulesBrowser methodsFor: 'private' stamp: 'SimonAllier 4/13/2012 17:00'!
bugRule
	| ruleId versionId manifestBuilder |

	ruleId :=  BugRule uniqueIdentifierName.
	versionId :=  BugRule identifierMinorVersionNumber.

	rulesModel selectedItem ifNotNil: [ :rule |
		manifestBuilder :=  checker manifestBuilderOf: rule class.
		(manifestBuilder hasFalsePositiveOf: ruleId version: versionId) 
			ifFalse: [manifestBuilder installFalsePositiveOf: ruleId version: versionId].
	 	manifestBuilder addFalsePositive: (rule class) of: ruleId version: versionId.
		
		CommentToDoWindow openOnCritic: rule class onRule: BugRule new .
	]

	! !

!CriticRulesBrowser methodsFor: 'system annoucements' stamp: 'SimonAllier 8/13/2012 10:43'!
classModified: anAnnouncement
"checks if a modification of a class fixes a warning. if true,  the true/false positives in the browser are update"
	|  class  |
	class := anAnnouncement class.
	self halt.
	class isManifest
		ifTrue: [ ^ self ].
		
	(criticModel criticsModelContains: anAnnouncement class)
		ifFalse: [^ self].
		
	self reapplyThisRule	! !

!CriticRulesBrowser methodsFor: 'system annoucements' stamp: 'SimonAllier 9/7/2012 11:35'!
classRemoved: anAnnouncement
	(environment classes anySatisfy: [ :cl | anAnnouncement classRemoved = cl ])
		ifFalse: [ ^ self ].
	rulesModel getList
		do: [ :rule | self removeClass: anAnnouncement classRemoved onRule: rule].
	self updateTree! !

!CriticRulesBrowser methodsFor: 'accessing' stamp: ''!
criticModel
	^ criticModel! !

!CriticRulesBrowser methodsFor: 'private' stamp: 'SimonAllier 4/13/2012 17:00'!
doNotUnderstandThisRule
	| ruleId versionId manifestBuilder |

	ruleId :=  DoNotUnderstandThisRule uniqueIdentifierName.
	versionId :=  DoNotUnderstandThisRule identifierMinorVersionNumber.

	rulesModel selectedItem ifNotNil: [ :rule |
		manifestBuilder :=  checker manifestBuilderOf: rule class.
		(manifestBuilder hasFalsePositiveOf: ruleId version: versionId) 
			ifFalse: [manifestBuilder installFalsePositiveOf: ruleId version: versionId].
	 	manifestBuilder addFalsePositive: (rule class) of: ruleId version: versionId.
		
		CommentToDoWindow openOnCritic: rule class onRule: DoNotUnderstandThisRule new .
	]

	! !

!CriticRulesBrowser methodsFor: 'accessing' stamp: ''!
environment: aEnv
	environment := aEnv
! !

!CriticRulesBrowser methodsFor: 'initialization' stamp: 'SimonAllier 5/22/2012 15:57'!
initFPTOCount

	rulesModel getRoots do: [:rule |
		self updateCountOf: rule]! !

!CriticRulesBrowser methodsFor: 'initialization' stamp: 'SimonAllier 8/28/2012 10:53'!
initRuleWrappingBlock

	rulesModel displayBlock: [:rule | 
		| fp td total text|
		
		
		fp := (countOfFalsePositive at: rule ifAbsent: [0]) .
		td := (countOfToDo at: rule ifAbsent: [0]) .
		total :=   (countOfProblem at: rule ifAbsent: [0]) .
		text := rule name, ' (FP: ' , fp asString, ', ToDo: ' ,td asString, ', Total: ',  total asString,  ')'.
		(total = 0)
			ifTrue: [ text ] 
			ifFalse: [
				fp >= total
					ifTrue: [text asStringMorph color: criticModel falsePositiveColor]
					 ifFalse: [text asStringMorph color: criticModel defaultColor]]
				
						
	]! !

!CriticRulesBrowser methodsFor: 'protocol' stamp: 'SimonAllier 7/30/2012 11:32'!
initialExtent

	^  (1400@800)! !

!CriticRulesBrowser methodsFor: 'initialization' stamp: 'SimonAllier 9/28/2012 13:54'!
initialize
	"Initialization code for CriticRulesBrowser"
	
	 super initialize.


	checker := SmalllintManifestChecker new.
	criticModel checker: checker.	
	countOfFalsePositive := Dictionary new.
	countOfToDo := Dictionary new.	
	countOfProblem := Dictionary new.	
		
! !

!CriticRulesBrowser methodsFor: 'initialization' stamp: 'SimonAllier 9/28/2012 13:54'!
initializePresenter

		rulesModel whenSelectedItemChanged: [:rule |
		(rule isNil or: [ rule isComposite ]) ifFalse: [
			criticModel resetSelection.
	 		criticModel rule: rule. 	
		
			criticModel setTextModelForNil]].! !

!CriticRulesBrowser methodsFor: 'initialization' stamp: 'SimonAllier 9/28/2012 13:55'!
initializeWidgets
	
	title := 'Critic Browser'.
	
	rulesModel := self instantiate: TreeModel.
	criticModel := CriticBrowser new.
		
	rulesModel childrenBlock: [:rule | 
		rule isComposite 
			ifTrue: [rule 	rules.]
			 ifFalse: [{}]
		
	]. 

		
	rulesModel menu: [:a :b | self menu: a shifted: b ].
	
	self initRuleWrappingBlock.
	! !

!CriticRulesBrowser methodsFor: 'menu' stamp: 'SimonAllier 4/2/2012 10:10'!
menu: aMenu shifted: aBoolean

	aMenu
		add: 'Browse rule' translated
		target: self
		selector: #browseRule;
		add: 'Do not understand this rule' translated
		target: self
		selector: #doNotUnderstandThisRule;
		add: 'This rule contains a bug' translated
		target: self
		selector: #bugRule;
		add: 'Reapply this rule'
		target: self
		selector: #reapplyThisRule;
		addLine;
		add: 'Ban this rule for all packages' translated
		target: self
		selector: #addRuleToFalsePositive;
			add: 'Unban this rule for all packages' translated
		target: self
		selector: #removeRuleToFalsePositive.
		
		
		
	^ aMenu! !

!CriticRulesBrowser methodsFor: 'system annoucements' stamp: 'SimonAllier 8/13/2012 10:26'!
methodAdded: anAnnouncement
	anAnnouncement methodClass isManifest
		ifFalse: [ ^ self ].
	self updateCountOf: rulesModel selectedItem.
	self updateTree! !

!CriticRulesBrowser methodsFor: 'system annoucements' stamp: 'SimonAllier 8/13/2012 10:29'!
methodModified: anAnnouncement
"checks if a modification of a method fixes a warning. if true,  the true positives in the browser are update"
"checks  if  a method of a manifest class is modified and update false positive in the browser"
	| class  |
	
	class := anAnnouncement methodClass.
	class isManifest 
		ifTrue: [ self updateCountOf: (rulesModel selectedItem).
			self updateTree
.			^ self].
		
	(criticModel criticsModelContains: anAnnouncement oldMethod)
		ifFalse: [^ self].
		
	self reapplyThisRule	
! !

!CriticRulesBrowser methodsFor: 'system annoucements' stamp: 'SimonAllier 8/13/2012 10:31'!
methodRemoved: anAnnouncement
	(environment classes anySatisfy: [ :cl | anAnnouncement itemClass = cl ])
		ifFalse: [ ^ self ].
	rulesModel getRoots do: [:root |
		root leaves do: [ :rule |
			 self removeClass: anAnnouncement methodClass selector: anAnnouncement selector onRule: rule]].
	self updateTree! !

!CriticRulesBrowser methodsFor: 'display' stamp: ''!
open

	window := self openWithSpec.
	^ window.! !

!CriticRulesBrowser methodsFor: 'protocol' stamp: ''!
openWithSpec

	window := super openWithSpec.
	^ window.! !

!CriticRulesBrowser methodsFor: 'message handling' stamp: 'SimonAllier 5/21/2012 14:28'!
perform: selector orSendTo: otherTarget
	"If I wish to intercept and handle selector myself, do it; else send it to otherTarget"
	^ (self respondsTo: selector) ifTrue: [self perform: selector] ifFalse: [otherTarget perform: selector]! !

!CriticRulesBrowser methodsFor: 'private' stamp: 'SimonAllier 5/22/2012 16:51'!
reapplyAllRules
	
	|  ruleCount total  rule |
	
	ruleCount := 0.
	rule := rulesModel getRoots first.
	total := rule leaves size.

	 rule leaves do: [ :r |
		ruleCount := ruleCount + 1.
		self setTitle: 'run rules: ', r name, ' (', ruleCount asString, '/',  total asString ,')'  .
		self reapplyRule: r ]. 	
	self setTitle: 'Critics Browser'.
	
	self updateCountOf: rule.
	 criticModel updateList.
	 rulesModel updateTree! !

!CriticRulesBrowser methodsFor: 'private' stamp: 'SimonAllier 5/22/2012 15:58'!
reapplyRule: aRule

	|  oldCritics |
	
	oldCritics := aRule critics.
	aRule resetResult.
	
	environment packages do: [:package |
		checker runRules:   aRule onPackage: package.
	]. 	
	
	(oldCritics \ (aRule critics)) do: [:each |
		self addTruePositive: each onRule: aRule].
	
	checker rule: aRule. ! !

!CriticRulesBrowser methodsFor: 'private' stamp: 'SimonAllier 5/22/2012 16:23'!
reapplyThisRule

	| rule |
	
	 rulesModel selectedItem isNil
		ifTrue: [^ self].
	
	rule := rulesModel selectedItem. 
	
	rule leaves do: [:each |
		self reapplyRule: each]. 
	

	criticModel resetSelection. 
	criticModel rule: rule.
	checker rule: rule. 
	self updateCountOf: rule.
	criticModel updateList. 
	self updateTree ! !

!CriticRulesBrowser methodsFor: 'system annoucements' stamp: 'SimonAllier 8/13/2012 10:15'!
registerToAnnouncements

	SystemAnnouncer uniqueInstance weak
		"on: RPackageCreated send: #packageCreated: to: self;
		on: RPackageRenamed send: #packageRenamed: to: self;"
	
		"on: ClassAdded send: #classAdded: to: self;"
		"on: ClassCommented send: #classCommented: to: self;
		on: ClassRecategorized send: #classRecategorized: to: self;"
		on: ClassRemoved send: #classRemoved: to: self;
		"on: ClassRenamed send: #classRenamed: to: self;"
		"on: ClassReorganized send: #classReorganized: to: self;"
		
		on: MethodAdded send: #methodAdded: to: self;
		on: MethodModified send: #methodModified: to: self;
		
		on: MethodRemoved send: #methodRemoved: to: self.
		
"		on: ProtocolAdded send: #classRecategorized: to: self;
		on: ProtocolRemoved send: #classRecategorized: to: self."! !

!CriticRulesBrowser methodsFor: 'private' stamp: 'SimonAllier 3/29/2012 11:36'!
removeClass: aClass  onRule: aRule
	| result |

	result := aRule result.
	
	result isVariableEnvironment
		ifTrue: [
			aClass classVarNames do: [ :var | result removeClass: aClass classVariable: var ].
			aClass instVarNames do: [ :var | result removeClass: aClass instanceVariable: var ]]
		ifFalse:[
			result removeClass: aClass
		]
	! !

!CriticRulesBrowser methodsFor: 'private' stamp: 'SimonAllier 8/1/2012 13:34'!
removeClass: aClass selector: aSelector onRule: aRule
	| result |
	result := aRule result.
	result isClassEnvironment
		ifTrue: [ result removeClass: aClass ].
	result isSelectorEnvironment
		ifTrue: [ result removeClass: aClass selector: aSelector ].
	result isVariableEnvironment
		ifFalse: [ ^ self ].
	aClass classVarNames do: [ :var | result removeClass: aClass classVariable: var ].
	aClass instVarNames do: [ :var | result removeClass: aClass instanceVariable: var ]! !

!CriticRulesBrowser methodsFor: 'private' stamp: 'SimonAllier 5/22/2012 11:17'!
removeRuleToFalsePositive

	| manifestBuilder |
	rulesModel selectedItem ifNotNil: [ :rule |
		rule leaves do: [: r |
			r critics do: [:cl |
				manifestBuilder := checker manifestBuilderOf: cl. 
				manifestBuilder removeRejectRule: r class uniqueIdentifierName]
		]].
	criticModel updateList.
	
	! !

!CriticRulesBrowser methodsFor: 'accessing' stamp: 'SimonAllier 5/22/2012 16:00'!
rules: aCompositeRule

	self rulesModel roots: {aCompositeRule}
	
	
! !

!CriticRulesBrowser methodsFor: 'accessing' stamp: ''!
rulesModel

	^ rulesModel! !

!CriticRulesBrowser methodsFor: 'protocol' stamp: 'SimonAllier 7/27/2012 11:09'!
setTitle: aTitle
	title := aTitle.
	self window updateTitle 
	"self window
		ifNotNil: [:w | w title: aTitle ]"! !

!CriticRulesBrowser methodsFor: 'protocol' stamp: 'SimonAllier 7/27/2012 11:08'!
title
	^ title! !

!CriticRulesBrowser methodsFor: 'private' stamp: 'SimonAllier 5/22/2012 16:55'!
updateCountOf: aRule

	aRule isNil ifTrue: [^ self].
	checker rule: aRule.
	aRule isComposite 
		ifTrue: [aRule rules do: [:rule |
			self updateCountOf:rule].
	countOfFalsePositive 
		at: aRule
		put: (aRule rules inject: 0 into: [:count :each | 
			count + countOfFalsePositive at: each]).
	countOfToDo 
		at: aRule
		put: (aRule rules inject: 0 into: [:count :each | 
			count + countOfToDo at: each]).
	countOfProblem
		at: aRule
		put: (aRule rules inject: 0 into: [:count :each | 
			count + countOfProblem at: each]).
		^ self].

	countOfFalsePositive at: aRule put: ((checker falsePositiveOf: aRule) size).
	countOfToDo at: aRule put: ((checker toDoOf: aRule) size).
	countOfProblem at: aRule put: aRule critics size   ! !

!CriticRulesBrowser methodsFor: 'thread' stamp: 'SimonAllier 8/23/2012 15:14'!
updateTree

	thread ifNotNil: [ thread terminate ].
	thread := [ WorldState addDeferredUIMessage: [ 
			rulesModel updateTree ]] fork.! !

ComposableModel subclass: #CriticToolbar
	instanceVariableNames: 'ruleHolder criticHolder browseModel falsepositiveModel transformModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Manifest-CriticBrowser'!

!CriticToolbar commentStamp: '<historical>' prior: 0!
I'am a toolbar for the SmallLint Critics


Instance Variables
	browseModel:		<Object>
	criticHolder:		<Object>
	falsepositiveModel:		<Object>
	ruleHolder:		<Object>
	transformModel:		<Object>

browseModel
	- xxxxx

criticHolder
	- xxxxx

falsepositiveModel
	- xxxxx

ruleHolder
	- xxxxx

transformModel
	- xxxxx
!

!CriticToolbar class methodsFor: 'specs' stamp: 'SimonAllier 9/28/2012 13:55'!
defaultSpec
<spec>

	^SpecLayout composed
		newRow: [:r |
			r 
				add: #browseModel;
				add: #transformModel;
				add: #falsepositiveModel
			]  height: 25! !

!CriticToolbar methodsFor: 'private' stamp: ''!
browseCritic

	criticHolder contents
		ifNotNil: [:elem | 
			elem isBehavior 
				ifTrue: [ elem theNonMetaClass  browse]
				ifFalse: [elem browse] ] ! !

!CriticToolbar methodsFor: 'accessing' stamp: ''!
browseModel

	^ browseModel! !

!CriticToolbar methodsFor: 'protocol' stamp: ''!
critic: aCritic

	criticHolder contents: aCritic! !

!CriticToolbar methodsFor: 'accessing' stamp: ''!
falsepositiveModel

	^ falsepositiveModel! !

!CriticToolbar methodsFor: 'initialization' stamp: ''!
initialize

	super initialize.

	criticHolder := nil asValueHolder.
	ruleHolder := nil asValueHolder.
	browseModel := self instantiate: ButtonModel.
	transformModel := self instantiate: ButtonModel.
	falsepositiveModel := self instantiate: ButtonModel.

	self setFocusOrder.
	
	self setBrowseModel.
	self setTransformModel.
	self setFalsepositiveModel.

	self registerForChanges.! !

!CriticToolbar methodsFor: 'initialization' stamp: 'SimonAllier 7/24/2012 14:07'!
initializeWidgets! !

!CriticToolbar methodsFor: 'initialization' stamp: 'SimonAllier 9/28/2012 13:55'!
registerForChanges

	criticHolder whenChangedDo: [:contents || boolean |
		boolean := contents notNil.
		browseModel state: (boolean and: [ browseModel enabled ]).
		transformModel state: (boolean and: [ transformModel enabled ]).
		falsepositiveModel state: (boolean and: [ falsepositiveModel enabled ]) ]
! !

!CriticToolbar methodsFor: 'protocol' stamp: ''!
rule: aRule
	
	ruleHolder contents: aRule.
	
	aRule isTransformationRule 
		ifTrue: [transformModel enabled: true]	
		ifFalse: [transformModel enabled: false]
! !

!CriticToolbar methodsFor: 'initialization' stamp: ''!
setBrowseModel
	
	browseModel
		state: false;
		label: 'Browse';
		action: [ self browseCritic ].
	
! !

!CriticToolbar methodsFor: 'initialization' stamp: ''!
setFalsepositiveModel
	
	falsepositiveModel
		state: false;
		label: 'False Positive';
		action: [  ].
	
! !

!CriticToolbar methodsFor: 'initialization' stamp: ''!
setFocusOrder

	self focusOrder
		add: browseModel;
		add: transformModel;
		add: falsepositiveModel.
		! !

!CriticToolbar methodsFor: 'initialization' stamp: ''!
setTransformModel
	
	transformModel
		state: false;
		label: 'Transform';
		action: [ self transformCritic ].
	
! !

!CriticToolbar methodsFor: 'private' stamp: ''!
transformCritic

	| changeCode rule selection |
	
	rule := ruleHolder contents
		ifNotNil: [:r | r ].
	rule isTransformationRule 
		ifFalse: [^ self].
			
	selection := criticHolder contents
		ifNotNil: [:critic | critic].			
	selection ifNotNil: [	
		changeCode := (rule changes detect: [:ch |
			((ch changeClassName) = (selection methodClass name)) & (ch selector = selection selector)]) source.
	
		selection methodClass compile: changeCode]! !

!CriticToolbar methodsFor: 'accessing' stamp: ''!
transformModel

	^ transformModel! !

!CriticToolbar methodsFor: 'initialization' stamp: ''!
whenFalsePositiveClickedDo: aBlock

	self falsepositiveModel whenActionPerformedDo: aBlock! !

!CriticToolbar methodsFor: 'initialization' stamp: ''!
whenTransformClickedDo: aBlock

	self transformModel whenActionPerformedDo: aBlock! !

ComposableModel subclass: #SelectBrowser
	instanceVariableNames: 'toSelectModel selectedModel addButtonModel addAllButtonModel removeButtonModel removeAllButtonModel nextButtonModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Manifest-CriticBrowser'!

!SelectBrowser class methodsFor: 'specs' stamp: 'SimonAllier 9/28/2012 13:56'!
defaultSpec

		<spec>
	
	^ SpecLayout composed
		newColumn: [:c |
			c
			newRow: [:r |
				r 
					add: #toSelectModel;
					addSplitter;
					add:  #selectedModel];
			newRow: [:r |
				r 
					add:#addButtonModel;
					add:#addAllButtonModel;
					add:#removeButtonModel;
					add:#removeAllButtonModel;
					add: #nextButtonModel ] height: 25]	! !

!SelectBrowser methodsFor: 'accessing' stamp: ''!
addAllButtonModel
	^ addAllButtonModel! !

!SelectBrowser methodsFor: 'accessing' stamp: ''!
addButtonModel
	^ addButtonModel! !

!SelectBrowser methodsFor: 'initialization' stamp: 'SimonAllier 9/28/2012 13:56'!
initializeWidgets

	self instantiateModels: #(
		addButtonModel ButtonModel
		addAllButtonModel ButtonModel 
		removeButtonModel ButtonModel
		removeAllButtonModel ButtonModel
		nextButtonModel ButtonModel ).
		
	self setFocusOrder.

	
	
	self setAddButtonModel. 
	self setAddAllButtonModel. 
	self setRemoveButtonModel. 
	self setRemoveAllButtonModel. 
	self setNextButtonModel. ! !

!SelectBrowser methodsFor: 'accessing' stamp: ''!
items: aCollection
	
	toSelectModel items: (self sort: aCollection)
! !

!SelectBrowser methodsFor: 'private' stamp: ''!
nextAction
	self subclassResponsibility
! !

!SelectBrowser methodsFor: 'accessing' stamp: ''!
nextButtonModel
	^ nextButtonModel! !

!SelectBrowser methodsFor: 'accessing' stamp: ''!
removeAllButtonModel
	^ removeAllButtonModel! !

!SelectBrowser methodsFor: 'accessing' stamp: ''!
removeButtonModel
	^ removeButtonModel! !

!SelectBrowser methodsFor: 'accessing' stamp: ''!
selectedModel
	^ selectedModel! !

!SelectBrowser methodsFor: 'initialization' stamp: ''!
setAddAllButtonModel
	
	addAllButtonModel
		state: false;
		label: 'Add All';
		action: [ self  addAllItems].
	
! !

!SelectBrowser methodsFor: 'initialization' stamp: ''!
setAddButtonModel
	
	addButtonModel
		state: false;
		label: 'Add';
		action: [ self addItems].
	
! !

!SelectBrowser methodsFor: 'initialization' stamp: ''!
setFocusOrder

	self focusOrder
		add: addButtonModel;
		add: addAllButtonModel;
		add: removeButtonModel;
		add: removeAllButtonModel.
		! !

!SelectBrowser methodsFor: 'initialization' stamp: ''!
setNextButtonModel
	
	nextButtonModel
		state: false;
		label: 'Next';
		action: [ self  nextAction].
	
! !

!SelectBrowser methodsFor: 'initialization' stamp: ''!
setRemoveAllButtonModel
	
	removeAllButtonModel
		state: false;
		label: 'Remove All';
		action: [ self  removeAllItems].
	
! !

!SelectBrowser methodsFor: 'initialization' stamp: ''!
setRemoveButtonModel
	
	removeButtonModel
		state: false;
		label: 'Remove';
		action: [ self removeItems ].
	
! !

!SelectBrowser methodsFor: 'accessing' stamp: ''!
toSelectModel
	^ toSelectModel! !

SelectBrowser subclass: #SelectPackageBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Manifest-CriticBrowser'!

!SelectPackageBrowser class methodsFor: 'instance creation' stamp: 'SimonAllier 3/29/2012 15:46'!
open
	
	self new items: MCWorkingCopy allManagers;
		openWithSpec ! !

!SelectPackageBrowser class methodsFor: 'specs' stamp: ''!
title
	^ 'Select packages'! !

!SelectPackageBrowser methodsFor: 'private' stamp: 'SimonAllier 5/21/2012 16:09'!
addAllItems
	| tmp |
	
	tmp := self sort: (selectedModel listItems asOrderedCollection addAll: (toSelectModel listItems);yourself ).

	selectedModel  items: tmp.
	toSelectModel  items: {}.
		
	toSelectModel updateList.
	selectedModel updateList.  	  ! !

!SelectPackageBrowser methodsFor: 'private' stamp: 'SimonAllier 5/21/2012 16:09'!
addItems
	
	toSelectModel selectedItems
		ifNotNil: [:items |  
			selectedModel  items: (self sort:(selectedModel listItems asOrderedCollection addAll: items;yourself) ).
			toSelectModel   items:  (self sort:(toSelectModel listItems asOrderedCollection removeAll: items;yourself) ).
			].
		toSelectModel updateList.
		selectedModel updateList.  	  ! !

!SelectPackageBrowser methodsFor: 'initialize-release' stamp: 'SimonAllier 7/24/2012 11:31'!
initialize
	| wrappingBlock |
	
	super initialize.
	
	toSelectModel := self instantiate: ListComposableModel.
	selectedModel := self instantiate: ListComposableModel.
	selectedModel beMultipleSelection.
	toSelectModel beMultipleSelection.
	
	wrappingBlock := [:package |
		package packageName].
	
	toSelectModel displayBlock: wrappingBlock.
	selectedModel displayBlock: wrappingBlock.! !

!SelectPackageBrowser methodsFor: 'private' stamp: 'SimonAllier 9/28/2012 15:11'!
nextAction
	| env package|
	
	package :=  (selectedModel listItems) collect: [:each |
		each package packageSet].
	env := RBPackageEnvironment new packages: package.
	SelectRuleBrowser openWithEnvironment: env.
	
	self delete
	
		
! !

!SelectPackageBrowser methodsFor: 'private' stamp: 'SimonAllier 5/21/2012 16:09'!
removeAllItems

	| tmp |
	
	tmp := self sort: (toSelectModel listItems asOrderedCollection addAll: (selectedModel listItems);yourself ).
	
	toSelectModel   items: tmp.
	selectedModel items: {}.
		
	toSelectModel updateList.
	selectedModel updateList.  	  ! !

!SelectPackageBrowser methodsFor: 'private' stamp: 'SimonAllier 5/21/2012 16:09'!
removeItems
	
	selectedModel selectedItems
		ifNotNil: [:items | 
			toSelectModel items: ( self sort: (toSelectModel listItems asOrderedCollection addAll: items;yourself))..
			selectedModel items: (self sort: (selectedModel listItems asOrderedCollection removeAll: items;yourself)).
			].
		toSelectModel updateList.
		selectedModel updateList.  	  ! !

!SelectPackageBrowser methodsFor: 'private' stamp: 'SimonAllier 5/21/2012 16:09'!
sort: aCollection
	
	^ aCollection asOrderedCollection sort: [:e1 :e2 | (e1 asString) < (e2 asString)].! !

SelectBrowser subclass: #SelectRuleBrowser
	instanceVariableNames: 'environment selectRule'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Manifest-CriticBrowser'!

!SelectRuleBrowser class methodsFor: 'instance creation' stamp: 'SimonAllier 7/31/2012 10:52'!
openWithEnvironment: aEnv
	
	self new items: (RBCompositeLintRule allGoodRules rules);
		environment: aEnv;
		openWithSpec;
		updateTree . ! !

!SelectRuleBrowser class methodsFor: 'specs' stamp: ''!
title
	^ 'Select rules'! !

!SelectRuleBrowser methodsFor: 'private' stamp: 'SimonAllier 5/22/2012 11:43'!
addAllItems
	
	toSelectModel getRoots do: [:item |  
		selectRule addAll: (item leaves)].
	
		self updateTree .  	  ! !

!SelectRuleBrowser methodsFor: 'private' stamp: 'SimonAllier 5/22/2012 13:51'!
addItems
	
	toSelectModel selectedItem
		ifNotNil: [:item |  
			selectRule addAll: (item leaves)
			].
		self updateTree   	  ! !

!SelectRuleBrowser methodsFor: 'accessing' stamp: ''!
environment: aEnv
	environment := aEnv! !

!SelectRuleBrowser methodsFor: 'initialize-release' stamp: 'SimonAllier 7/24/2012 14:05'!
initialize
	| wrappingBlock childrenBlockS childrenBlockTS|
	
	super initialize.
	
	toSelectModel := self instantiate: TreeModel.
	selectedModel := self instantiate: TreeModel.
	selectRule := Set new.
	
	
	 childrenBlockS := [:rule | 
		rule isComposite 
			ifTrue: [rule rules select: [:r |
					(selectRule anySatisfy:  [:sr | sr = r]) or: [r isComposite] ]]
			 ifFalse: [{}]
	]. 

	 childrenBlockTS := [:rule | 
		rule isComposite 
			ifTrue: [rule rules select: [:r |
					(selectRule anySatisfy: [:sr | sr = r]) not or: [r isComposite]]]
			 ifFalse: [{}]
	]. 

	toSelectModel childrenBlock: childrenBlockTS.
	selectedModel childrenBlock: childrenBlockS.
	wrappingBlock := [:rule |
		rule name].
	
	toSelectModel displayBlock: wrappingBlock.
	selectedModel displayBlock: wrappingBlock.! !

!SelectRuleBrowser methodsFor: 'accessing' stamp: 'SimonAllier 5/22/2012 10:45'!
items: aCollection
	
	toSelectModel roots: aCollection.
	selectedModel roots: aCollection
! !

!SelectRuleBrowser methodsFor: 'private' stamp: 'SimonAllier 9/11/2012 14:18'!
nextAction
	|rules|
	
	self delete.
	
	rules := 	selectedModel getRoots.
	rules do: [ :each | 
		each leaves
			do: [ :leave | 
				(selectRule anySatisfy: [ :r | r = leave ])
					ifFalse: [ each removeRule: leave]]].
				
		rules := rules select: [ :each | 
				each rules isEmpty not].
					
			 				
	CriticRulesBrowser openOnRule: (RBCompositeLintRule new name: 'selected Rules'; rules: rules) onEnvironment: environment! !

!SelectRuleBrowser methodsFor: 'private' stamp: 'SimonAllier 5/22/2012 11:43'!
removeAllItems
	
	selectedModel getRoots do: [:item |  
		selectRule removeAllFoundIn: (item leaves)].
	
		self updateTree 	  ! !

!SelectRuleBrowser methodsFor: 'private' stamp: 'SimonAllier 5/22/2012 13:51'!
removeItems
	
	selectedModel selectedItem
		ifNotNil: [:item |  
			selectRule removeAllFoundIn: (item leaves)
		].
		self updateTree  	  ! !

!SelectRuleBrowser methodsFor: 'private' stamp: 'SimonAllier 5/22/2012 11:43'!
updateTree
		toSelectModel updateTree.
		selectedModel updateTree.  	  ! !

!RBMultiEnvironment methodsFor: '*Manifest-CriticBrowser' stamp: 'SimonAllier 3/30/2012 11:43'!
isMultiEnvironment
	^ true! !

!RBMultiEnvironment methodsFor: '*Manifest-CriticBrowser' stamp: ''!
removeClass: aClass
	environmentDictionaries keys do: [:key |
		(environmentDictionaries at: key) removeClass: aClass]! !

Object subclass: #CriticBrowserIcons
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Manifest-CriticBrowser'!

CriticBrowserIcons class
	instanceVariableNames: 'icons'!

CriticBrowserIcons class
	instanceVariableNames: 'icons'!

!CriticBrowserIcons class methodsFor: 'accesing' stamp: 'SimonAllier 8/29/2012 10:46'!
exclamationIcon 

	
	^  icons
			at: #'exclamationIcon'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self  exclamationIconContents readStream) ].
! !

!CriticBrowserIcons class methodsFor: 'icons' stamp: 'SimonAllier 8/28/2012 16:15'!
exclamationIconContents
	"Private - Method generated"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAJPSURBVDjLpZPLS5RhFMYfv9QJ
lelTQZwRb2OKlKuINuHGLlBEBEOLxAu46oL0F0QQFdWizUCrWnjBaDHgThCMoiKkhUONTqmj
mDp2GZ0UnWbmfc/ztrC+GbM2dXbv4ZzfeQ7vefKMMfifyP89IbevNNCYdkN2kawkCZKfSPZT
OGTf6Y/m1uflKlC3LvsNTWArr9BT2LAf+W73dn5jHclIBFZyfYWU3or7T4K7AJmbl/yG7EtX
1BQXNTVCYgtgbAEAYHlqYHlrsTEVQWr63RZFuqsfDAcdQPrGRR/JF5nKGm9xUxMyr0YBAEXX
HgIANq/3ADQobD2J9fAkNiMTMSFb9z8ambMAQER3JC1XttkYGGZXoyZEGyTHRuBuPgBTUu7V
SnUAgAUAWutOV2MjZGkehgYUA6O5A0AlkAyRnotiX3MLlFKduYCqAtuGXpyH0XQmOj+TIURt
51OzURTYZdBKV2UBSsOIcRp/TVTT4ewK6idECAihtUKOArWcjq/B8tQ6UkUR31+OYXP4sTOd
isivrkMyHodWejlXwcC38Fvs8dY5xaIId89VlJy7ACpCNCFCuOp8+BJ6A631gANQSg1mVmOx
xGQYRW2nHMha4B5WA3chsv22T5/B13AIicWZmNZ6cMchTXUe81Okzz54pLi0uQWp+TmkZqMw
xsBV74Or3od4OISPr0e3SHa3PX0f3HXKofNH/UIG9pZ5PeUth+CyS2EMkEqs4fPEOBJLsysk
e48/+xD8oxcAYPzs4QaS7RR2kbLTTOTQieczfzfTv8QPldGvTGoF6/8AAAAASUVORK5CYII='! !

!CriticBrowserIcons class methodsFor: 'initialization' stamp: 'SimonAllier 8/29/2012 10:47'!
initialize
	
	icons := IdentityDictionary new! !

!CriticBrowserIcons class methodsFor: 'accesing' stamp: 'SimonAllier 8/29/2012 10:46'!
wrenchOrangeIcon

	^  icons
			at: #'wrenchOrangeIcon'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self  wrench_orangeIconContents readStream) ].
! !

!CriticBrowserIcons class methodsFor: 'icons' stamp: 'SimonAllier 8/28/2012 16:14'!
wrench_orangeIconContents
	"Private - Method generated"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAHaSURBVDjLlZO7a1NRHMfzfzhI
KQ5OHR1ddRRBLA6lg4iTd5PSas37YR56Y2JiHgg21uoFxSatCVFjbl5iNBBiMmUJgWwZhCB4
pR9/V4QKfSQdDufF5/v7nu85xwJYprV0Oq0kk8luIpEw4vG48f/eVDiVSikCTobDIePxmGg0
yokEBO4OBgNGoxH5fJ5wOHwygVgsZpjVW60WqqqWzbVgMIjf78fn8xlTBcTy736/T7VaJRQK
fQoEArqmafR6Pdxu9/ECkUjkglje63Q6NBoNisUihUKBcrlMpVLB6XR2D4df3VQnmRstsWzU
63WazSZmX6vV0HWdUqmEw+GY2Gw25SC8dV1l1wrZNX5s3qLdbpPL5fB6vXumZalq2O32rtVq
VQ6GuGnCd+HbFnx9AZrC+MkSHo/np8vlmj/M7f4ks6yysyawgB8fwPv70HgKG8v8cp/7fFRO
/+AllewqNJ/DhyBsi9A7J1QTkF4E69mXRws8u6ayvSJwRqoG4K2Md+ygxyF5FdbPaMfdlIXU
ZfiyAUWx/OY25O4JHBP4CtyZ16a9EwuRi1CXs+5K1ew6lB9DXERX517P8tEsPDzfNIP6C5Ye
QewSrJyeCd4P0bnwXYISy3MCn5oZNtsf3pH46e7XBJcAAAAASUVORK5CYII='! !

Object subclass: #ManifestManifestCriticBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Manifest-CriticBrowser'!

!ManifestManifestCriticBrowser class methodsFor: 'meta data' stamp: 'SimonAllier 7/27/2012 10:23'!
rejectClasses
^ #()! !

!ManifestManifestCriticBrowser class methodsFor: 'meta data' stamp: 'SimonAllier 8/1/2012 13:34'!
rejectRules
^ #('LawOfDemeterRule' 'TranslateLiteralsInMenusRule' 'MethodHasNoTimeStampRule')! !

!ManifestManifestCriticBrowser class methodsFor: 'meta data' stamp: 'SimonAllier 9/11/2012 16:06'!
ruleCodeCruftLeftInMethodsRuleV1FalsePositive
^ #()! !

!ManifestManifestCriticBrowser class methodsFor: 'meta data' stamp: 'SimonAllier 7/27/2012 10:24'!
ruleEquivalentSuperclassMethodsRuleV1FalsePositive
^ #(#(#(#RGMethodDefinition #(#CriticBrowser #perform:orSendTo: #false)) #'2012-07-27T10:24:23.09+02:00') #(#(#RGMethodDefinition #(#CriticRulesBrowser #perform:orSendTo: #false)) #'2012-07-27T10:24:23.090000001+02:00') )! !

!ManifestManifestCriticBrowser class methodsFor: 'meta data' stamp: 'SimonAllier 8/1/2012 13:34'!
ruleGuardClauseRuleV1TruePositive
^ #(#(#(#RGMethodDefinition #(#CriticRulesBrowser #removeClass:selector:onRule: #false)) #'2012-08-01T13:34:20.99+02:00') )! !

!ManifestManifestCriticBrowser class methodsFor: 'meta data' stamp: 'SimonAllier 8/22/2012 16:43'!
ruleInconsistentMethodClassificationRuleV1TruePositive
^ #(#(#(#RGMethodDefinition #(#CriticBrowser #takeKeyboardFocus #false)) #'2012-08-22T16:33:48.84+02:00') #(#(#RGMethodDefinition #(#'SelectPackageBrowser class' #title #true)) #'2012-08-22T16:33:48.858+02:00') #(#(#RGMethodDefinition #(#'SelectBrowser class' #defaultSpec #true)) #'2012-08-22T16:33:48.881+02:00') #(#(#RGMethodDefinition #(#CriticRulesBrowser #initializeWidgets #false)) #'2012-08-22T16:34:43.502+02:00') #(#(#RGMethodDefinition #(#CriticRulesBrowser #initialize #false)) #'2012-08-22T16:34:43.516+02:00') #(#(#RGMethodDefinition #(#CriticRulesBrowser #initialExtent #false)) #'2012-08-22T16:37:05.755+02:00') #(#(#RGMethodDefinition #(#CriticRulesBrowser #openWithSpec #false)) #'2012-08-22T16:37:05.767+02:00') #(#(#RGMethodDefinition #(#CriticRulesBrowser #addModelItemsToWindowMenu: #false)) #'2012-08-22T16:39:40.56+02:00') #(#(#RGMethodDefinition #(#CriticBrowser #perform:orSendTo: #false)) #'2012-08-22T16:40:15.182+02:00') #(#(#RGMethodDefinition #(#'CriticRulesBrowser class' #defaultSpec #true)) #'2012-08-22T16:40:36.841+02:00') #(#(#RGMethodDefinition #(#CriticRulesBrowser #perform:orSendTo: #false)) #'2012-08-22T16:41:59.639+02:00') #(#(#RGMethodDefinition #(#SelectPackageBrowser #initialize #false)) #'2012-08-22T16:42:47.043+02:00') #(#(#RGMethodDefinition #(#'SelectRuleBrowser class' #title #true)) #'2012-08-22T16:42:47.054+02:00') #(#(#RGMethodDefinition #(#SelectBrowser #initializeWidgets #false)) #'2012-08-22T16:43:20.929+02:00') )! !

!ManifestManifestCriticBrowser class methodsFor: 'meta data' stamp: 'SimonAllier 8/29/2012 13:40'!
ruleMissingSubclassResponsibilityRuleV1FalsePositive
^ #()! !

!ManifestManifestCriticBrowser class methodsFor: 'meta data' stamp: 'SimonAllier 8/29/2012 13:40'!
ruleMissingSubclassResponsibilityRuleV1TODO
^ #(#(#(#RGMethodDefinition #(#SelectPackageBrowser #removeAllItems #false)) #'2012-08-01T13:28:23.517+02:00') #(#(#RGMethodDefinition #(#SelectRuleBrowser #removeAllItems #false)) #'2012-08-01T13:28:23.517000001+02:00') #(#(#RGMethodDefinition #(#SelectPackageBrowser #addAllItems #false)) #'2012-08-01T13:28:23.52+02:00') #(#(#RGMethodDefinition #(#SelectRuleBrowser #removeItems #false)) #'2012-08-01T13:28:23.520000001+02:00') #(#(#RGMethodDefinition #(#SelectRuleBrowser #addItems #false)) #'2012-08-01T13:28:23.520000002+02:00') #(#(#RGMethodDefinition #(#SelectPackageBrowser #removeItems #false)) #'2012-08-01T13:28:23.520000003+02:00') #(#(#RGMethodDefinition #(#SelectPackageBrowser #addItems #false)) #'2012-08-01T13:28:23.520000005+02:00') #(#(#RGMethodDefinition #(#SelectRuleBrowser #addAllItems #false)) #'2012-08-29T13:40:56.703+02:00') )! !

!ManifestManifestCriticBrowser class methodsFor: 'meta data' stamp: 'SimonAllier 7/27/2012 10:23'!
ruleMissingTranslationsInMenusRuleV1FalsePositive
^ #(#(#(#RGMethodDefinition #(#CriticRulesBrowser #addModelItemsToWindowMenu: #false)) #'2012-07-27T10:23:41.061+02:00') )! !

!ManifestManifestCriticBrowser class methodsFor: 'meta data' stamp: 'SimonAllier 8/1/2012 13:27'!
ruleMissingYourselfRuleV1FalsePositive
^ #(#(#(#RGMethodDefinition #(#SelectRuleBrowser #nextAction #false)) #'2012-08-01T13:27:54.443+02:00') )! !

!ManifestManifestCriticBrowser class methodsFor: 'meta data' stamp: 'SimonAllier 8/23/2012 10:18'!
ruleOnlyReadOrWrittenTemporaryRuleV1FalsePositive
^ #()! !

!ManifestManifestCriticBrowser class methodsFor: 'meta data' stamp: 'SimonAllier 8/23/2012 10:18'!
ruleOnlyReadOrWrittenTemporaryRuleV1TruePositive
^ #(#(#(#RGMethodDefinition #(#CriticRulesBrowser #initRuleWrappingBlock #false)) #'2012-08-23T10:18:23.839+02:00') )! !

!ManifestManifestCriticBrowser class methodsFor: 'meta data' stamp: 'SimonAllier 8/1/2012 13:28'!
ruleSentNotImplementedRuleV1TODO
^ #(#(#(#RGMethodDefinition #(#SelectBrowser #items: #false)) #'2012-08-01T13:28:05.731+02:00') #(#(#RGMethodDefinition #(#SelectBrowser #setAddButtonModel #false)) #'2012-08-01T13:28:05.731000001+02:00') #(#(#RGMethodDefinition #(#SelectBrowser #setAddAllButtonModel #false)) #'2012-08-01T13:28:05.731000002+02:00') #(#(#RGMethodDefinition #(#SelectBrowser #setRemoveButtonModel #false)) #'2012-08-01T13:28:05.731000003+02:00') #(#(#RGMethodDefinition #(#SelectBrowser #setRemoveAllButtonModel #false)) #'2012-08-01T13:28:05.731000004+02:00') )! !

!ManifestManifestCriticBrowser class methodsFor: 'meta data' stamp: 'SimonAllier 8/29/2012 13:40'!
ruleSentNotImplementedRuleV1TruePositive
^ #(#(#(#RGMethodDefinition #(#CriticBrowser #iconFor: #false)) #'2012-08-29T13:40:08.585+02:00') )! !

!ManifestManifestCriticBrowser class methodsFor: 'meta data' stamp: 'SimonAllier 8/22/2012 16:30'!
ruleStringConcatenationRuleV1FalsePositive
^ #(#(#(#RGMethodDefinition #(#CriticRulesBrowser #reapplyAllRules #false)) #'2012-08-22T16:30:38.967+02:00') #(#(#RGMethodDefinition #(#CriticRulesBrowser #applyRules #false)) #'2012-08-22T16:30:38.967000001+02:00') )! !

!ManifestManifestCriticBrowser class methodsFor: 'meta data' stamp: 'SimonAllier 9/5/2012 14:26'!
ruleTransformationRuleV1TruePositive
^ #(#(#(#RGMethodDefinition #(#Test #foo #false)) #'2012-09-05T14:26:40.028+02:00') )! !

!ManifestManifestCriticBrowser class methodsFor: 'meta data' stamp: 'SimonAllier 8/1/2012 13:34'!
ruleUnclassifiedMethodsRuleV1TruePositive
^ #(#(#(#RGMethodDefinition #(#CommentWindow #initialExtent #false)) #'2012-08-01T13:34:12.208+02:00') )! !
CriticBrowserIcons initialize!
